//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cspin"
#pragma link "perfgrap"
#pragma link "GSpin"
#pragma link "cgauges"
#pragma link "systray"
#pragma resource "*.dfm"
TMainForm *MainForm;
TIniFile *WorkTimesIni;
double WorkingHours;
TTime StartTime;
double PayPerHour;
double IQuitDate;
int MonthTotalDayz;
int TotalDayz;
int DayzLeft;

//---------------------------------------------------------------------------
void __fastcall TMainForm::CalcDaysLeft()
{
  double vDate;
  Word vYear,vMonth,vDay;

  vDate=Date();
  vDate++;
  DayzLeft=0;
  vDay=0;
  while (!(vDay==1))
  {
    DecodeDate(vDate,vYear,vMonth,vDay);
    if ((DayOfWeek(vDate)!=6) && (DayOfWeek(vDate)!=7))
    {
      DayzLeft++;
    }
    vDate++;
  }

  vDate=EncodeDate(vYear,vMonth-1,1);
  vDate++;
  TotalDayz=0;
  if ((DayOfWeek(vDate)!=6) && (DayOfWeek(vDate)!=7))
  {
    MonthTotalDayz++;
  }
  vDay=0;
  while (!(vDay==1))
  {
    DecodeDate(vDate,vYear,vMonth,vDay);
    if ((DayOfWeek(vDate)!=6) && (DayOfWeek(vDate)!=7))
    {
      MonthTotalDayz++;
    }
    vDate++;
  }

  MonthTotalDayzMaskEdit->Text=IntToStr(DayzLeft)+" / "+IntToStr(MonthTotalDayz);
}

void __fastcall TMainForm::CalcIQuitDaysLeft()
{
  double vDate;

  vDate=Date();
  TotalDayz=0;
  while (!(IQuitDate==vDate))
  {
    if ((DayOfWeek(vDate)!=6) && (DayOfWeek(vDate)!=7))
    {
      TotalDayz++;
    }
    vDate++;
  }

  TotalDayzMaskEdit->Text=IntToStr(TotalDayz);
}

void __fastcall TMainForm::ReadIni()
{
  TIniFile *WorkTimesIni=new

  TIniFile(ExtractFilePath(Application->ExeName)+"WorkTime.ini");
  if (WorkTimesIni->ReadDate("Config","LastDate",Date()-1)!=Date())
  {
    MainForm->StartDateTime->Time=Time();
    MainForm->TotalHoursEdit->Text="08.60";
    MainForm->TotalHoursEditChange(MainForm->TotalHoursEdit);
  }
  else
  {
    MainForm->StartDateTime->Time=WorkTimesIni->ReadTime("Config","LastStartTime",StrToTime("08:00"));
    MainForm->TotalHoursEdit->Text=WorkTimesIni->ReadString("Config","LastHours","08.60");
  }
  MainForm->Top=WorkTimesIni->ReadInteger("Config","Top",MainForm->Top);
  MainForm->Left=WorkTimesIni->ReadInteger("Config","Left",MainForm->Left);
  PayPanel->Visible=WorkTimesIni->ReadBool("Config","UsePay",false);
  PayPerHour=StrToFloat(WorkTimesIni->ReadString("Config","PayPerHour","00.00"));
  IQuitDate=WorkTimesIni->ReadDate("Config","IQuitDate",Date());
  WorkTimesIni->Free();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WriteIni()
{
  TIniFile *WorkTimesIni=new
  TIniFile(ExtractFilePath(Application->ExeName)+"WorkTime.ini");
  WorkTimesIni->WriteDate("Config","LastDate",Date());
  WorkTimesIni->WriteTime("Config","LastStartTime",MainForm->StartDateTime->Time);
  WorkTimesIni->WriteString("Config","LastHours",MainForm->TotalHoursEdit->Text);
  WorkTimesIni->WriteInteger("Config","Top",MainForm->Top);
  WorkTimesIni->WriteInteger("Config","Left",MainForm->Left);
  WorkTimesIni->Free();
}
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CloseButtonClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::HideButtonClick(TObject *Sender)
{
  WriteIni();
  MainForm->Hide();
  WorkTimeTrayIcon->AddIcon();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::TotalHoursEditChange(TObject *Sender)
{
  char TempS[5];
  double r;

  try
  {
    sprintf(TempS,"%s",TotalHoursEdit->Text);
    WorkingHours=atof(TempS);
    r=(long double)StartDateTime->Time+(long double)WorkingHours/24;
    EndDateTime->Time=(TTime)r;
  }
  __except (1)
  {
    WorkingHours=0;
  }
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::StartDateTimeChange(TObject *Sender)
{
  double r;

  StartTime=StartDateTime->Time;
  r=(long double)StartDateTime->Time+(long double)WorkingHours/24;
  EndDateTime->Time=(TTime)r;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::EndDateTimeChange(TObject *Sender)
{
  float r;
  char s[4];

  r=(long double)EndDateTime->Time-(long double)StartDateTime->Time;
  r*=24;
  sprintf(s,"%02.02f",r);
  TotalHoursEdit->Text=s;
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::TheTimerTimer(TObject *Sender)
{
  double ElapsedTime,RemainingTime;
  double EarnedToday;
  char s[4],c1[20];

  ElapsedTime=((long double)Time()-(int)Time())-((long double)StartTime-(int)StartTime);

  EarnedToday=ElapsedTime*24;
  EarnedToday*=PayPerHour;
  sprintf(s,"%02.02f",EarnedToday);
  EarnedMaskEdit->Text=s;
  EarnedToday=PayPerHour*WorkingHours;
  sprintf(s,"%02.02f",EarnedToday);
  TotalMaskEdit->Text=s;


  ElapseLabel->Text=FormatDateTime("hh:mm:ss",(TTime)ElapsedTime);

  RemainingTime=((long double)EndDateTime->Time-(int)EndDateTime->Time)-((long double)Time()-(int)Time());

  sprintf(c1,"%02.0f / %02.0f",(WorkingHours-ElapsedTime*24)*60*60,WorkingHours*24*60*60);
  SecondsMaskEdit->Text=c1;

  if ((RemainingTime>0) && (WorkingHours>0))
  {
    RemTimeLabel->Text=FormatDateTime("hh:mm:ss",(TTime)RemainingTime);
    if (MainProgressBar->Progress!=(int)((100*ElapsedTime)/(ElapsedTime+RemainingTime)))
    {
      MainProgressBar->Progress=(int)((100*ElapsedTime)/(ElapsedTime+RemainingTime));
      Application->ProcessMessages();
    }
    WorkTimeTrayIcon->TrayHint="Elapsed Time: "+TimeToStr(RemainingTime)+" | Precent Done: "+MainProgressBar->Progress+"%";
  }
  else
  {
    Beep();
    WorkTimeTrayIcon->TrayHint="--:--";
    RemTimeLabel->Text="00:00:00";
    ShowBtnClick(Sender);
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  ReadIni();
  TotalHoursEditChange(Sender);
  StartDateTimeChange(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
  WriteIni();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CompactButtonClick(TObject *Sender)
{
  if (MainForm->Height>148)
  {
    MainForm->Height=148;
    CompactButton->Caption="+";
  }
  else
  {
    MainForm->Height=316;
    CompactButton->Caption="-";
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CSpinButton1DownClick(TObject *Sender)
{
  char s[4];

  if (WorkingHours>=0.5)
  {
    WorkingHours-=0.5;
    sprintf(s,"%02.02f",WorkingHours);
    TotalHoursEdit->Text=s;
  }
  else
  {
    WorkingHours=0;
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CSpinButton1UpClick(TObject *Sender)
{
  char s[4];

  if (WorkingHours<=23.5)
  {
    WorkingHours+=0.5;
    sprintf(s,"%02.02f",WorkingHours);
    TotalHoursEdit->Text=s;
  }
  else
  {
    WorkingHours=24;
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CloseBtnClick(TObject *Sender)
{
  WorkTimeTrayIcon->RemoveIcon();
  CloseButtonClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ShowBtnClick(TObject *Sender)
{
  WorkTimeTrayIcon->RemoveIcon();
  MainForm->Show();
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::OptionsBtnClick(TObject *Sender)
{
  WriteIni();
  OptionsForm->ShowModal();
  ReadIni();
  CalcIQuitDaysLeft();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::HidePayBtnClick(TObject *Sender)
{
  PayPanel->Visible=!PayPanel->Visible;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormShow(TObject *Sender)
{
  CalcDaysLeft();
  CalcIQuitDaysLeft();
  TheTimerTimer(Sender);
}
//---------------------------------------------------------------------------

